## uclibc 0.9.26-3.1

=== debian/changelog ===
uclibc (0.9.26-3.1) unstable; urgency=low

  * NMU during BSP
  * Really, really fix build on all architectures (Closes: #235014)

 -- Frank Lichtenheld <djpig@debian.org>  Fri, 26 Mar 2004 15:51:33 +0100

uclibc (0.9.26-3) unstable; urgency=low

  * No, really.  Fix sparc compile problems (Closes: #235014)

 -- David Schleef <ds@schleef.org>  Tue, 02 Mar 2004 17:39:58 -0800

uclibc (0.9.26-2) unstable; urgency=low

  * Fix sparc compile problems (Closes: #235014)

 -- David Schleef <ds@schleef.org>  Thu, 26 Feb 2004 17:26:29 -0800

uclibc (0.9.26-1) unstable; urgency=low

  * New upstream release(s).  (Closes: #225507)
  * Add typedefs for __kernel_old_dev_t.  (Closes: #234374)

 -- David Schleef <ds@schleef.org>  Wed, 25 Feb 2004 14:47:53 -0800

uclibc (0.9.23-1) unstable; urgency=low

  * New upstream release.  Should fix build problems on m68k
    (Closes: #217761).
  * Change installation directory to /usr/$(arch)-uclibc-linux
    instead of -linux-uclibc.  This makes it easier to build
    toolchains with these packages.
  * The gcc wrapper has been removed upstream, but it's been
    copied locally until a transition is decided.  It is likely
    that uclibc-toolchain will be removed in the next upload.

 -- David Schleef <ds@schleef.org>  Wed, 12 Nov 2003 15:41:06 -0800

uclibc (0.9.21-2) unstable; urgency=low

  * enable a bunch of new options.
  * print the config file after 'make config'.  This should help
    debugging m68k build failures if the first change doesn't
    fix it.

 -- David Schleef <ds@schleef.org>  Thu, 02 Oct 2003 15:07:27 -0700

uclibc (0.9.21-1) unstable; urgency=low

  * New upstream version.
  * Added text to README.Debian about how to use uclibc-toolchain.
  * Switch to using kernel-source-2.4.22
  * Upgrade standards version to 3.6.1
  * extra/scripts/fix_includes.sh: requires /bin/bash

 -- David Schleef <ds@schleef.org>  Thu, 18 Sep 2003 10:07:46 -0700

uclibc (0.9.20-2) unstable; urgency=low

  * Turn off UCLIBC_PROFILING because it's causing build problems on
    arm.

 -- David Schleef <ds@schleef.org>  Wed, 02 Jul 2003 19:12:36 -0700

uclibc (0.9.20-1) unstable; urgency=low

  * New upstream release.

 -- David Schleef <ds@schleef.org>  Tue, 01 Jul 2003 12:16:31 -0700

uclibc (0.9.19-1) unstable; urgency=low

  * New upstream version.
  * Disable ctor/dtor in gcc wrapper, which effectively disables
    C++ support in the wrapper.  Shouldn't be a big problem, since
    there are other problems with using the wrapper with C++.  Erik
    recommends building a complete toolchain. (Closes: #181783).

 -- David Schleef <ds@schleef.org>  Mon, 03 Mar 2003 12:13:47 -0800

uclibc (0.9.18-1) unstable; urgency=low

  * New upstream release
  * Update to kernel-source-2.4.20
  * Upgrade .shlib dependencies
  * Enable IPv6 and other options (Closes: #174092)
  * Remove build directory from ld script (Closes: #161474)
  * Add/fix /lib/ld-uClibc.so.0 symlink

 -- David Schleef <ds@schleef.org>  Wed, 12 Feb 2003 12:40:38 -0800

uclibc (0.9.16-6) unstable; urgency=low

  * Reenable FPU and C99 math support that were accidentally
    disabled in the move to 0.9.16. (Closes: #171359, #172686)
  * Fix ${arch}-uclibc-xx installation directory (should be /usr/bin)
  * Make ldd work with dh_shlibdeps (Closes: #171282, #171287)

 -- David Schleef <ds@schleef.org>  Wed, 11 Dec 2002 15:55:52 -0800

uclibc (0.9.16-5) unstable; urgency=low

  * (Attempt #2) Removed some default flags on sparc.

 -- David Schleef <ds@schleef.org>  Wed, 27 Nov 2002 13:56:39 -0800

uclibc (0.9.16-4) unstable; urgency=low

  * Removed some default flags on m68k and sparc, since they don't
    work with the standard gcc.
  * Stripped quotes around ARCH_CFLAGS

 -- David Schleef <ds@schleef.org>  Fri, 22 Nov 2002 15:15:25 -0800

uclibc (0.9.16-3) unstable; urgency=low

  * Got the last change wrong.
  * Enabled alpha build.

 -- David Schleef <ds@schleef.org>  Thu, 21 Nov 2002 16:24:27 -0800

uclibc (0.9.16-2) unstable; urgency=low

  * Disable shared lib loader on m68k and sparc

 -- David Schleef <ds@schleef.org>  Wed, 20 Nov 2002 19:45:31 -0800

uclibc (0.9.16-1) unstable; urgency=low

  * New upstream release (Closes: #169650, #169547)
  * Rewrote much of the installation code to use dh_ more
  * Removed gasp man page link (Closes: #169648)
  * Upstream uses new configuration method (Closes: #169513)

 -- David Schleef <ds@schleef.org>  Mon, 18 Nov 2002 11:32:43 -0800

uclibc (0.9.12-2) unstable; urgency=low

  * Make sure MAS_MMU=true on m68k

 -- David Schleef <ds@schleef.org>  Thu, 27 Jun 2002 15:04:59 -0700

uclibc (0.9.12-1) unstable; urgency=low

  * New upstream release.
  * Attempt to fix MIPS build again. (Closes: #150313)

 -- David Schleef <ds@schleef.org>  Mon, 24 Jun 2002 16:26:18 -0700

uclibc (0.9.11-cvs20020619-1) unstable; urgency=low

  * This is an automatic snapshot of uClibc CVS
  * new snapshot
  * MIPS build should have been fixed in the last entry, which
    was not actually uploaded (Closes: #150313).

 -- David Schleef <ds@schleef.org>  Wed, 19 Jun 2002 11:45:59 -0700

uclibc (0.9.11-cvs20020420-1) unstable; urgency=low

  * Many of the configs have broken CROSS definitions.  Compensate
    for that in debian/rules.

 -- David Schleef <ds@schleef.org>  Sat, 20 Apr 2002 15:40:39 -0700

uclibc (0.9.11-cvs20020419-1) unstable; urgency=low

  * new upstream snapshot
    - should fix build on sparc and m68kk (Closes: #142708)
  * I wanted to have a debian package for the 0.9.11 release, but
    that was rather broken on PowerPC.
  * Updated kernel source to 2.4.18

 -- David Schleef <ds@schleef.org>  Fri, 19 Apr 2002 10:15:59 -0700

uclibc (0.9.10-cvs20020406-1) unstable; urgency=low

  * new upstream snapshot
    - should fix build on mips
  * updated shlibs to 0.9.10, since it was broken previously (actually
    was done in previous upload)
  * create top-level lib/, for safety

 -- David Schleef <ds@schleef.org>  Sat,  6 Apr 2002 14:34:41 -0800



=== debian/control ===
Source: uclibc
Section: devel
Priority: optional
Maintainer: David Schleef <ds@schleef.org>
Build-Depends: debhelper, bzip2, kernel-source-2.4.22
Standards-Version: 3.5.8

Package: libuclibc-dev
Section: devel
Architecture: alpha arm i386 m68k mips mipsel powerpc sh sparc
Depends: libuclibc0 (= ${Source-Version})
Description: A small implementation of the C library
 uClibc is an implementation of the standard C library that is
 much smaller than glibc, which makes it useful for embedded
 systems.  This package includes header files and development
 libraries necessary to compile applications that use uClibc.

Package: libuclibc0
Section: libs
Architecture: alpha arm i386 m68k mips mipsel powerpc sh sparc
Depends:
Description: A small implementation of the C library
 uClibc is an implementation of the standard C library that is
 much smaller than glibc, which makes it useful for embedded
 systems.  This package provides only the run-time libraries.
 .
 The Debian binary packages for uClibc do not provide the necessary
 components for using uClibc as the primary library on a system,
 as might be done for an embedded system.

Package: uclibc-toolchain
Section: devel
Architecture: alpha arm i386 m68k mips mipsel powerpc sh sparc
Depends: gcc|c-compiler, binutils, ${shlibs:Depends}
Recommends: libuclibc-dev
Conflicts: uclibc-gcc
Replaces: uclibc-gcc
Description: A compiler wrapper for uClibc
 This package includes utilities that function as a toolchain for
 compiling with uClibc instead of the native libc.  The utilities
 have names such as powerpc-uclibc-gcc (depending on the architecture),
 and should behave identically to the base utilities, except that
 they use headers and libraries provided in the libuclibc-dev
 package.  Most utilities are symbolic links to the correct underlying
 utility, although gcc and ld are implemented as wrapper binaries that
 call gcc and ld with the necessary arguments and command line options.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=3

#include version
major=$(shell grep '^MAJOR_VERSION' Rules.mak|sed 's/.*=//')
minor=$(shell grep '^MINOR_VERSION' Rules.mak|sed 's/.*=//')
version:=$(strip $(major)).$(strip $(minor))

kernel_version=2.4.22
kernel_source=kernel-source-$(kernel_version)

builddir=$(shell pwd)

DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
target=$(DEB_HOST_GNU_CPU)
#target=arm

with_shared_libs=y
#ifeq ($(target),powerpc)
#with_shared_libs=n
#endif

ifeq ($(with_shared_libs),y)
shared_libs_true=true
else
shared_libs_true=false
endif

ifneq ($(target),$(DEB_HOST_GNU_CPU))
target_suffix=-$(target)
endif

ifneq ($(target),$(DEB_HOST_GNU_CPU))
cross_options = --cross="$(target)-linux-"
else
cross_options = --cross=""
endif

p_dev=libuclibc-dev$(target_suffix)
p_lib=libuclibc0$(target_suffix)
p_gcc=uclibc$(target_suffix)-toolchain

debian/control: debian/control.in debian/rules
	sed -e s/_TARGET_/$(target_suffix)/ \
	  -e "s/_ARCHS_/alpha arm i386 m68k mips mipsel powerpc sh sparc/" \
	  -e "s/_KERNEL_/$(kernel_source)/" \
	  debian/control.in >debian/control

build: build-stamp
build-stamp: debian/control
	dh_testdir

ifeq (0,0)
	# Brute force method of getting kernel headers
	tar --bzip2 -xf /usr/src/$(kernel_source).tar.bz2 \
	  $(kernel_source)/include \
	  $(kernel_source)/Makefile

	# Hack to get include/asm-arm/arch directory.  This should
	# stay here, and not move to the top-level Makefile, since
	# it adds a link _in the kernel source_, which is almost
	# certainly wrong in most situations.
ifeq ($(target),arm)
	ln -s arch-sa1100 $(kernel_source)/include/asm-arm/arch
	ln -s proc-armo $(kernel_source)/include/asm-arm/proc
endif

	touch $(kernel_source)/include/linux/autoconf.h
else
	mkdir -p $(kernel_source)/include
	cp -r /usr/include/linux $(kernel_source)/include/linux
	cp -r /usr/include/asm $(kernel_source)/include/asm
	#ln -s /usr/include/linux $(kernel_source)/linux
	#ln -s /usr/include/asm $(kernel_source)/asm
endif

	# Various stupid programs use linux/version.h to find the
	# Linux version.
	( \
		echo '#define UTS_RELEASE "$(kernel_version)"'; \
		echo '#define KERNEL_VERSION(a,b,c) (((a) << 16) + ((b) << 8) + (c))'; \
		echo '#define LINUX_VERSION_CODE KERNEL_VERSION($(shell echo $(kernel_version) | sed s/\\./,/g))'; \
	) >$(kernel_source)/include/linux/version.h

	cp debian/config .config
	echo TARGET_$(target)=y >>.config
	echo CONFIG_ARCH=$(target) >>.config
	echo CONFIG_386=y >>.config
ifeq ($(findstring $(target),alpha m68k sparc),$(target))
	echo BUILD_UCLIBC_LDSO=n >>.config
endif
	echo UCLIBC_PROFILING=n >>.config
	echo SHARED_LIB_LOADER_PATH=\"/lib\" >>.config
	echo KERNEL_SOURCE=\"$(builddir)/$(kernel_source)\" >>.config
	echo 'RUNTIME_PREFIX="/usr/$$(TARGET_ARCH)-uclibc-linux/"' >>.config
	echo 'DEVEL_PREFIX="/usr/$$(TARGET_ARCH)-uclibc-linux"' >>.config
	echo 'DEVEL_TOOL_PREFIX="$$(DEVEL_PREFIX)"' >>.config
	echo 'SYSTEM_DEVEL_PREFIX="/usr"' >>.config

	yes '' | make oldconfig

	cat .config

	mkdir -p lib

	$(MAKE) TARGET_ARCH=$(target)
	make -C debian/gcc-uClibc

	touch build-stamp

clean: debian/control
	dh_testdir
	dh_testroot
	rm -f build-stamp

	rm -rf kernel-source-*

	# Add here commands to clean up after the build process.
	-$(MAKE) -C debian/gcc-uClibc clean
	-$(MAKE) distclean

	-rm -rf libc/misc/locale/locale_data.c

	-rm -f Config

	-find . -type l | xargs rm -f

	dh_clean

install: build debian/control
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	-rm debian/tmp
	-mkdir debian/tmp
	#ln -s tmp debian/tmp

	# Add here commands to install the package into debian/tmp.
	$(MAKE) install PREFIX=`pwd`/debian/tmp
	$(MAKE) install_runtime PREFIX=`pwd`/debian/tmp

	install -d debian/tmp/usr/bin/
	install -m755 debian/gcc-uClibc/$(target)-uclibc-ld \
		debian/tmp/usr/bin/$(target)-uclibc-linux-ld
	install -m755 debian/gcc-uClibc/$(target)-uclibc-gcc \
		debian/tmp/usr/bin/$(target)-uclibc-linux-gcc

	install -d debian/tmp/usr/share/man/man1
	install -m 644 debian/uclibc-gcc.1 \
	  debian/tmp/usr/share/man/man1/$(target)-uclibc-linux-gcc.1
	(cd debian/tmp/usr/share/man/man1; \
	  ln -sf $(target)-uclibc-linux-gcc.1.gz $(target)-uclibc-linux-cc.1.gz; \
	  ln -sf $(target)-uclibc-linux-gcc.1.gz $(target)-uclibc-linux-ld.1.gz; \
	  for x in addr2line ar as cpp nm objcopy objdump ranlib \
	  size strings strip;do \
	    ln -sf $$x.1.gz $(target)-uclibc-linux-$$x.1.gz;done)
	(cd debian/tmp/usr/bin; \
	  for x in addr2line ar as cpp nm objcopy objdump ranlib \
	  size strings strip;do \
	    ln -sf $$x $(target)-uclibc-linux-$$x;done)
	mkdir -p debian/tmp/usr/$(target)-uclibc-linux/bin
	(cd debian/tmp/usr/$(target)-uclibc-linux/bin; \
	  for x in addr2line ar as cpp gcc cc nm objcopy objdump ranlib \
	  size strings strip;do \
	    ln -sf ../../bin/$(target)-uclibc-linux-$$x $(target)-uclibc-linux-$$x;done)

	install -d debian/tmp/usr/share/man/man1
	install -m 644 debian/uclibc-ldd.1 \
	  debian/tmp/usr/share/man/man1/$(target)-uclibc-linux-ldd.1
	install -m 644 debian/uclibc-ldconfig.1 \
	  debian/tmp/usr/share/man/man1/$(target)-uclibc-linux-ldconfig.1
	install -m 644 debian/uclibc-readelf.1 \
	  debian/tmp/usr/share/man/man1/$(target)-uclibc-linux-readelf.1

	mkdir debian/tmp/lib/
	cd debian/tmp/lib && ln -sf /usr/$(target)-uclibc-linux/lib/ld-uClibc.so.0 .

	cd debian/tmp && perl ../fixlinks

	(cd debian/tmp; find . -name '.*' -exec rm -f '{}' ';')

# Build architecture-independent files here.
binary-indep:

# Build architecture-dependent files here.
binary-arch: build install
#	dh_testversion
	dh_testdir
	dh_testroot

	dh_movefiles
#	dh_installdebconf	
	dh_installdocs
	dh_installexamples
	dh_installmenu
#	dh_installemacsen
#	dh_installpam
#	dh_installinit
	dh_installcron
#	dh_installmanpages -plibuclibc0
	dh_installinfo
#	dh_undocumented
	dh_installchangelogs 
	dh_link
	dh_strip
	dh_compress
	dh_fixperms -Xld-uClibc
	# You may want to make some executables suid here.
#	dh_suidregister
#	dh_makeshlibs
	dh_installdeb
#	dh_perl
#ifeq ($(target),$(DEB_HOST_GNU_CPU))
#	dh_shlibdeps --exclude=ld_uclibc -ldebian/$(p_lib)/usr/$(target)-uclibc-linux/lib
#else
	dh_shlibdeps --exclude=lib
#endif
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## uclibc 0.9.27

=== libcrypt/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
# Copyright (C) 2000-2002 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../
include $(TOPDIR)Rules.mak

CFLAGS+=$(SSP_ALL_CFLAGS)

LIBCRYPT=libcrypt.a
LIBCRYPT_SHARED=libcrypt.so
LIBCRYPT_SHARED_FULLNAME=libcrypt-$(MAJOR_VERSION).$(MINOR_VERSION).$(SUBLEVEL).so

CSRC = crypt.c des.c md5.c
OBJS=$(patsubst %.c,%.o, $(CSRC))

all: $(OBJS) $(LIBCRYPT)

$(LIBCRYPT): ar-target

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBCRYPT) $(OBJS)
	$(INSTALL) -d $(TOPDIR)lib
	$(RM) $(TOPDIR)lib/$(LIBCRYPT)
	$(INSTALL) -m 644 $(LIBCRYPT) $(TOPDIR)lib

$(OBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(OBJ): Makefile

shared: all
	$(LD) $(LDFLAGS) -soname=$(LIBCRYPT_SHARED).$(MAJOR_VERSION) \
		-o $(LIBCRYPT_SHARED_FULLNAME) --whole-archive $(LIBCRYPT) \
		--no-whole-archive $(TOPDIR)libc/misc/internals/interp.o \
		-L$(TOPDIR)lib -lc $(LDADD_LIBFLOAT) $(LIBGCC);
	$(INSTALL) -d $(TOPDIR)lib
	$(RM) $(TOPDIR)lib/$(LIBCRYPT_SHARED_FULLNAME) $(TOPDIR)lib/$(LIBCRYPT_SHARED).$(MAJOR_VERSION)
	$(INSTALL) -m 644 $(LIBCRYPT_SHARED_FULLNAME) $(TOPDIR)lib;
	$(LN) -sf $(LIBCRYPT_SHARED_FULLNAME) $(TOPDIR)lib/$(LIBCRYPT_SHARED)
	$(LN) -sf $(LIBCRYPT_SHARED_FULLNAME) $(TOPDIR)lib/$(LIBCRYPT_SHARED).$(MAJOR_VERSION)

clean: 
	$(RM) *.[oa] *~ core $(LIBCRYPT_SHARED)* $(LIBCRYPT_SHARED_FULLNAME)*

=== libutil/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
# Copyright (C) 2000-2002 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../
include $(TOPDIR)Rules.mak
LIBC=$(TOPDIR)libc.a

CFLAGS+=$(SSP_ALL_CFLAGS)

LIBUTIL=libutil.a
LIBUTIL_SHARED=libutil.so
LIBUTIL_SHARED_FULLNAME=libutil-$(MAJOR_VERSION).$(MINOR_VERSION).$(SUBLEVEL).so

CSRC=login.c login_tty.c logout.c logwtmp.c openpty.c
ifeq ($(strip $(ARCH_HAS_MMU)),y)
    CSRC+=forkpty.c
endif
OBJS=$(patsubst %.c,%.o, $(CSRC))

all: $(OBJS) $(LIBC)

$(LIBC): ar-target

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBUTIL) $(OBJS)
	$(INSTALL) -d $(TOPDIR)lib
	$(RM) $(TOPDIR)lib/$(LIBUTIL)
	$(INSTALL) -m 644 $(LIBUTIL) $(TOPDIR)lib/

$(OBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

shared: all
	$(LD) $(LDFLAGS) -soname=$(LIBUTIL_SHARED).$(MAJOR_VERSION) \
		-o $(LIBUTIL_SHARED_FULLNAME) --whole-archive $(LIBUTIL) \
		--no-whole-archive $(TOPDIR)libc/misc/internals/interp.o \
		-L$(TOPDIR)lib -lc $(LDADD_LIBFLOAT) $(LIBGCC);
	$(INSTALL) -d $(TOPDIR)lib
	$(RM) $(TOPDIR)lib/$(LIBUTIL_SHARED_FULLNAME) $(TOPDIR)lib/$(LIBUTIL_SHARED).$(MAJOR_VERSION)
	$(INSTALL) -m 644 $(LIBUTIL_SHARED_FULLNAME) $(TOPDIR)lib
	$(LN) -sf $(LIBUTIL_SHARED_FULLNAME) $(TOPDIR)lib/$(LIBUTIL_SHARED)
	$(LN) -sf $(LIBUTIL_SHARED_FULLNAME) $(TOPDIR)lib/$(LIBUTIL_SHARED).$(MAJOR_VERSION)

clean:
	$(RM) *.[oa] *~ core $(LIBUTIL_SHARED)* $(LIBUTIL_SHARED_FULLNAME)*

=== ldso/libdl/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
# Copyright (C) 2000-2002 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


TOPDIR=../../
include $(TOPDIR)Rules.mak

XXFLAGS=$(XWARNINGS) $(SSP_CFLAGS) $(SSP_ALL_CFLAGS)
ifeq ($(DODEBUG),y)
XXFLAGS+=-O0 -g3
else
XXFLAGS+=$(OPTIMIZATION)
endif
XXFLAGS+= $(XARCH_CFLAGS) $(CPU_CFLAGS) \
	-DUCLIBC_RUNTIME_PREFIX=\"$(RUNTIME_PREFIX)\" \
	-fno-builtin -nostdinc -D_LIBC -I$(TOPDIR)ldso/include -I$(TOPDIR)ldso/ldso -I. -I$(TOPDIR)include

XXFLAGS+=-isystem $(shell $(CC) -print-file-name=include)
XXFLAGS_NOPIC:=$(XXFLAGS)
ifeq ($(DOPIC),y)
    XXFLAGS += $(PICFLAG) -D__LIBDL_SHARED__
endif
ifeq ($(strip $(SUPPORT_LD_DEBUG)),y)
XXFLAGS+=-D__SUPPORT_LD_DEBUG__
endif

LIBDL=libdl.a
LIBDL_PIC=libdl_pic.a
LIBDL_SHARED=libdl.so
LIBDL_SHARED_FULLNAME=libdl-$(MAJOR_VERSION).$(MINOR_VERSION).$(SUBLEVEL).so

CSRC=libdl.c
OBJS=libdl.o
PIC_OBJS=libdl_pic.o

all: $(OBJS) $(LIBDL) shared

$(LIBDL): ar-target

$(LIBDL_PIC): ar-target

ar-target: $(OBJS) $(PIC_OBJS)
	$(AR) $(ARFLAGS) $(LIBDL) ../ldso/$(TARGET_ARCH)/resolve.o $(OBJS)
	$(AR) $(ARFLAGS) $(LIBDL_PIC) $(PIC_OBJS)
	$(INSTALL) -d $(TOPDIR)lib
	$(RM) $(TOPDIR)lib/$(LIBDL)
	$(INSTALL) -m 644 $(LIBDL) $(TOPDIR)lib


libdl.o: libdl.c
	$(CC) $(XXFLAGS_NOPIC) -c libdl.c -o libdl.o
	$(STRIPTOOL) -x -R .note -R .comment $*.o

libdl_pic.o: libdl.c
	$(CC) $(XXFLAGS) -c libdl.c -o libdl_pic.o
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(OBJ): Makefile

shared: $(LIBDL_PIC)
	$(LD) $(LDFLAGS) -soname=$(LIBDL_SHARED).$(MAJOR_VERSION) \
		-o $(LIBDL_SHARED_FULLNAME) -fini dl_cleanup --whole-archive $(LIBDL_PIC) \
		--no-whole-archive $(TOPDIR)/libc/misc/internals/interp.o \
		-L$(TOPDIR)/lib -lc $(LDADD_LIBFLOAT) $(LIBGCC);
	$(INSTALL) -d $(TOPDIR)lib
	$(RM) $(TOPDIR)lib/$(LIBDL_SHARED_FULLNAME) $(TOPDIR)lib/$(LIBDL_SHARED).$(MAJOR_VERSION)
	$(INSTALL) -m 644 $(LIBDL_SHARED_FULLNAME) $(TOPDIR)lib
	$(LN) -sf $(LIBDL_SHARED_FULLNAME) $(TOPDIR)lib/$(LIBDL_SHARED)
	$(LN) -sf $(LIBDL_SHARED_FULLNAME) $(TOPDIR)lib/$(LIBDL_SHARED).$(MAJOR_VERSION)

clean:
	$(RM) .depend $(LIBDL_SHARED)* $(LIBDL_SHARED_FULLNAME) core *.o *.a *.s *.i tmp_make foo *~

=== libc/string/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000-2003 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

TOPDIR=../../
include $(TOPDIR)Rules.mak

DIRS=

ifeq ($(UCLIBC_HAS_STRING_GENERIC_OPT),y)
DIRS += generic
endif

ifeq ($(UCLIBC_HAS_STRING_ARCH_OPT),y)
ifeq ($(TARGET_ARCH),$(wildcard $(TARGET_ARCH)))
DIRS += $(TARGET_ARCH)
endif
endif

ALL_SUBDIRS = generic arm frv i386 sh64 powerpc mips

MSRC= wstring.c
MOBJ=  basename.o bcopy.o bzero.o dirname.o ffs.o memccpy.o memchr.o memcmp.o \
	memcpy.o memmove.o mempcpy.o memrchr.o 	memset.o rawmemchr.o stpcpy.o \
	stpncpy.o strcasecmp.o strcasestr.o strcat.o strchrnul.o strchr.o \
	strcmp.o strcpy.o strcspn.o strdup.o strlen.o strncasecmp.o strncat.o \
	strncmp.o strncpy.o strndup.o strnlen.o strpbrk.o strrchr.o strsep.o \
	strspn.o strstr.o strtok.o strtok_r.o strerror.o _susv3_strerror_r.o \
	_string_syserrmsgs.o _glibc_strerror_r.o \
	_string_syssigmsgs.o sys_siglist.o strsignal.o psignal.o \
	 __xpg_basename.o strlcat.o strlcpy.o sys_errlist.o memmem.o

MOBJW= wcscasecmp.o wcscat.o wcschrnul.o wcschr.o wcscmp.o wcscpy.o wcscspn.o \
	wcsdup.o wcslen.o wcsncasecmp.o wcsncat.o wcsncmp.o wcsncpy.o \
	wcsnlen.o wcspbrk.o wcsrchr.o wcsspn.o wcsstr.o wcstok.o wmemchr.o \
	wmemcmp.o wmemcpy.o wmemmove.o wmempcpy.o wmemset.o wcpcpy.o wcpncpy.o \
	__wcslcpy.o \
	wcsxfrm.o strxfrm.o # wcscoll strcoll.o

MOBJx=
MOBJWx=

ifeq ($(UCLIBC_HAS_XLOCALE),y)
	MOBJx += strcasecmp_l.o strncasecmp_l.o
	MOBJWx += wcscasecmp_l.o wcsncasecmp_l.o wcsxfrm_l.o strxfrm_l.o
endif

#ffsl ffsll

OBJS=$(MOBJ) $(MOBJx)

ifeq ($(UCLIBC_HAS_WCHAR),y)
	OBJS += $(MOBJW) $(MOBJWx)
endif

all: $(LIBC) subdirs

$(LIBC): ar-target

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBC) $(OBJS)

$(MOBJ): $(MSRC)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(MOBJx): $(MSRC)
	$(CC) $(CFLAGS) -DL_$* -D__UCLIBC_DO_XLOCALE $< -c -o $*.o
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(MOBJW): $(MSRC)
	$(CC) $(CFLAGS) -DWANT_WIDE -DL_$* $< -c -o $*.o
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(MOBJWx): $(MSRC)
	$(CC) $(CFLAGS) -DWANT_WIDE -DL_$* -D__UCLIBC_DO_XLOCALE $< -c -o $*.o
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(COBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

clean: subdirs_clean
	$(RM) *.[oa] *~ core

subdirs: $(patsubst %, _dir_%, $(DIRS))
subdirs_clean: $(patsubst %, _dirclean_%, $(ALL_SUBDIRS))

$(patsubst %, _dir_%, $(DIRS)) : $(OBJS)
	$(MAKE) -C $(patsubst _dir_%, %, $@)

$(patsubst %, _dirclean_%, $(ALL_SUBDIRS)) : dummy
	$(MAKE) -C $(patsubst _dirclean_%, %, $@) clean

.PHONY: dummy

=== libc/string/generic/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000-2003 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

TOPDIR=../../../
include $(TOPDIR)Rules.mak

CSRC=	memchr.c memcmp.c memcpy.c memmem.c memmove.c mempcpy.c memrchr.c \
	memset.c rawmemchr.c strcat.c strchr.c strchrnul.c strcmp.c strcpy.c \
	strcspn.c strlen.c strncat.c strncmp.c strncpy.c strnlen.c \
	strrchr.c strsep.c strspn.c strstr.c strtok_r.c

COBJS=$(patsubst %.c,%.o, $(CSRC))

OBJS=$(COBJS)

all: $(OBJS) $(LIBC)

$(LIBC): ar-target

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBC) $(OBJS)

# $(MOBJ): $(MSRC)
# 	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
# 	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(COBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

clean:
	$(RM) *.[oa] *~ core

=== libc/string/powerpc/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000-2003 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

TOPDIR=../../../
include $(TOPDIR)Rules.mak

MSRC= string.c
MOBJ= memcpy.o memmove.o memset.o bzero.o 
OBJS=$(MOBJ)

all: $(OBJS) $(LIBC)

$(LIBC): ar-target

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBC) $(OBJS)

$(MOBJ): $(MSRC)
	$(CC) $(CFLAGS) -DL_$* $< -c -o $*.o
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(COBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

clean:
	$(RM) *.[oa] *~ core

=== libc/sysdeps/linux/nios2/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000-2003 Erik Andersen <andersen@uclibc.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

TOPDIR=../../../../
include $(TOPDIR)Rules.mak

CRT0_SRC = crt0.S
CRT0_OBJ = crt0.o crt1.o
CTOR_TARGETS=$(TOPDIR)lib/crti.o $(TOPDIR)lib/crtn.o

SSRC= __longjmp.S bsd-_setjmp.S bsd-setjmp.S setjmp.S vfork.S clone.S
SOBJS=$(patsubst %.S,%.o, $(SSRC))

CSRC= brk.c syscall.c
COBJS=$(patsubst %.c,%.o, $(CSRC))

OBJS=$(SOBJS) $(MOBJ) $(COBJS)

all: $(OBJS) $(LIBC)

$(LIBC): ar-target 

ar-target: $(OBJS) $(CRT0_OBJ) $(CTOR_TARGETS)
	$(AR) $(ARFLAGS) $(LIBC) $(OBJS)
	cp $(CRT0_OBJ) $(TOPDIR)lib/

$(CRT0_OBJ): $(CRT0_SRC)
	$(CC) $(ASFLAGS) -DL_$* $< -c -o $*.o
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(SOBJS): %.o : %.S
	$(CC) $(ASFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(COBJS): %.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

ifeq ($(strip $(UCLIBC_CTOR_DTOR)),y)
crti.o: crti.S
	$(CC) $(ASFLAGS) -c crti.S -o crti.o

$(TOPDIR)lib/crti.o: crti.o
	$(INSTALL) -d $(TOPDIR)lib/
	cp crti.o $(TOPDIR)lib/

crtn.o: crtn.S
	$(CC) $(ASFLAGS) -c crtn.S -o crtn.o

$(TOPDIR)lib/crtn.o: crtn.o
	$(INSTALL) -d $(TOPDIR)lib/
	cp crtn.o $(TOPDIR)lib/
else
$(TOPDIR)lib/crti.o:
	$(INSTALL) -d $(TOPDIR)lib/
	$(AR) $(ARFLAGS) $(TOPDIR)lib/crti.o
$(TOPDIR)lib/crtn.o:
	$(INSTALL) -d $(TOPDIR)lib/
	$(AR) $(ARFLAGS) $(TOPDIR)lib/crtn.o
endif


headers:
	$(LN) -fs ../libc/sysdeps/linux/nios2/fpu_control.h $(TOPDIR)/include/

clean:
	$(RM) *.[oa] *~ core
	$(RM) bits/sysnum.h
	$(RM) $(TOPDIR)/include/fpu_control.h

## uclibc 0.9.30.1

=== debian/changelog ===
uclibc (0.9.30.1-1) unstable; urgency=low

  * Redo the packaging, again.
  * Only build uclibc-source package on Debian arches for now

 -- Simon Richter <sjr@debian.org>  Mon,  7 Dec 2009 18:13:57 +0100

uclibc (0.9.30-1) unstable; urgency=low

  * New upstream version
  * Use linux-libc-dev package instead of linux-source
  * Build 32/64 bit and multilib variants

 -- Simon Richter <sjr@debian.org>  Sun, 23 Nov 2008 18:59:25 +0100

uclibc (0.9.28.3-1) unstable; urgency=low

  * New upstream version
  * Repackaged from the ground up
    + Now supports cross compilation
    + Probably lots of bugs introduced

 -- Simon Richter <sjr@debian.org>  Thu, 11 Oct 2007 17:43:50 +0200

uclibc (0.9.27-1) unstable; urgency=low

  * New upstream release.
  * Acknowledge NMU (Closes: #268989) and fix the bug it caused
    (Closes: #284326)
  * Add gross versioned dependency for gcc-3.3, and make sure we use
    gcc-3.3 in the gcc wrapper. (Closes: #304806)

 -- David Schleef <ds@schleef.org>  Mon, 18 Apr 2005 13:29:53 -0700

uclibc (0.9.26-cvs20040816-5.1) unstable; urgency=high

  * Non-Maintainer Upload.
  * Add libuclibc-dev to uclibc-toolchain's Depends:. (Closes: #268989)

 -- Steinar H. Gunderson <sesse@debian.org>  Tue, 14 Sep 2004 01:23:12 +0200

uclibc (0.9.26-cvs20040816-5) unstable; urgency=low

  * debian/rules: fix up headers from linux-kernel-headers, since
    they contain conflicting definitions.

 -- David Schleef <ds@schleef.org>  Wed, 25 Aug 2004 01:26:31 -0600

uclibc (0.9.26-cvs20040816-4) unstable; urgency=low

  * libc/sysdeps/linux/arm/bits/kernel_types.h: Add hack for
    __kernel_dev_t typedef conflict with /usr/include headers.
  * libc/sysdeps/linux/common/madvise.c: pull patch from HEAD to
    make use of __NR_madvise conditional on its definition.
  * debian/rules: prefix should be DEB_HOST_GNU_CPU instead of
    TARGET_ARCH
  * debian/gcc-uClibc/Makefile: likewise

 -- David Schleef <ds@schleef.org>  Mon, 23 Aug 2004 14:05:48 -0700

uclibc (0.9.26-cvs20040816-3) unstable; urgency=low
  
  * extra/Configs/Config.m68k: remove inclusion of kernel source
    directory, since no other architecture does this and it causes
    problems if our kernel source dir is /usr/include
  * extra/Configs/Config.mipsel: use TARGET_ARCH=mips
  * debian/rules: don't set TARGET_ARCH, since it's set correctly
    in the config file.

 -- David Schleef <ds@schleef.org>  Thu, 19 Aug 2004 15:56:26 -0700

uclibc (0.9.26-cvs20040816-2) unstable; urgency=low

  * Revert typedefs for __kernel_old_dev_t, since it's in upstream
    now.

 -- David Schleef <ds@schleef.org>  Wed, 18 Aug 2004 13:34:14 -0700

uclibc (0.9.26-cvs20040816-1) unstable; urgency=low

  * Update to recent CVS snapshot on the advice of upstream.

 -- David Schleef <ds@schleef.org>  Mon, 16 Aug 2004 19:35:42 -0700

uclibc (0.9.26-5) unstable; urgency=low

  * README.Debian: fix mistake in name of compiler. (Closes: #264163)
  * Use linux-kernel-headers instead of untarring the kernel source.
    This should fix FTBTS problems that were caused by the kernel
    upgrade. (Closes: #261318)
  * Fix extra /'s in directories (Closes: #244704)
  * Add mips 2.6 support patch from Thiemo Seufer

 -- David Schleef <ds@schleef.org>  Mon, 16 Aug 2004 12:38:12 -0700

uclibc (0.9.26-4) unstable; urgency=low

  * Bump kernel-source build dep to 2.4.26 (Closes: #253528)

 -- David Schleef <ds@schleef.org>  Mon, 12 Jul 2004 16:58:57 -0700

=== debian/control ===
Source: uclibc
Section: libs
Priority: extra
Maintainer: Simon Richter <sjr@debian.org>
Build-Depends: linux-libc-dev, debhelper (>= 7)
Standards-Version: 3.8.3

Package: uclibc-source
Section: devel
Architecture: all
Description: Small C library implementation - source
 uClibc is an implementation of the standard C library that is much smaller
 than glibc, which makes it useful for embedded systems. This package provides
 only the run-time libraries.
 .
 This package provides the source code for the library, for toolchain
 bootstrap purposes.

Package: libuclibc-dev
Section: libdevel
Architecture: any
Depends: uclibc0.9.30.1 (= ${binary:Version})
Description: Small C library implementation - development files
 uClibc is an implementation of the standard C library that is much smaller
 than glibc, which makes it useful for embedded systems. This package provides
 only the run-time libraries.
 .
 This package provides the necessary headers and static libraries for compiling
 and linking programs against uClibc.

Package: libuclibc-pic
Section: libdevel
Architecture: any
Description: Small C library implementation - PIC static library
 uClibc is an implementation of the standard C library that is much smaller
 than glibc, which makes it useful for embedded systems. This package provides
 only the run-time libraries.
 .
 This package provides a static archive of the individual functions, but
 compiled appropriately for shared libraries. This allows building a reduced
 variant of the shared library that is smaller, but only guaranteed to work
 with a fixed set of applications.

Package: uclibc0.9.30.1
Section: libs
Architecture: any
Description: Small C library implementation - runtime libraries
 uClibc is an implementation of the standard C library that is much smaller
 than glibc, which makes it useful for embedded systems. This package provides
 only the run-time libraries.
 .
 This package provides the run-time binaries.

Package: uclibc32-0.9.30.1
Section: libs
Architecture: any
Description: Small C library implementation - 32 bit runtime libraries
 uClibc is an implementation of the standard C library that is much smaller
 than glibc, which makes it useful for embedded systems. This package provides
 only the run-time libraries.
 .
 This package provides the run-time binaries for the 32 bit variant of this
 architecture.

Package: uclibc64-0.9.30.1
Section: libs
Architecture: any
Description: Small C library implementation - 64 bit runtime libraries
 uClibc is an implementation of the standard C library that is much smaller
 than glibc, which makes it useful for embedded systems. This package provides
 only the run-time libraries.
 .
 This package provides the run-time binaries for the 64 bit variant of this
 architecture.

Package: uclibc0.9.30.1-multilib
Section: libs
Architecture: any
Description: Small C library implementation - non-standard runtime libraries
 uClibc is an implementation of the standard C library that is much smaller
 than glibc, which makes it useful for embedded systems. This package provides
 only the run-time libraries.
 .
 This package provides the run-time binaries for ABIs different from the
 system default.

Package: libc0.9.30.1uc
Section: libs
Architecture: any
Description: Small C library implementation - C library
 uClibc is an implementation of the standard C library that is much smaller
 than glibc, which makes it useful for embedded systems. This package provides
 only the run-time libraries.
 .
 This package provides the C library.

Package: lib32c0.9.30.1uc
Section: libs
Architecture: any
Description: Small C library implementation - 32 bit C library
 uClibc is an implementation of the standard C library that is much smaller
 than glibc, which makes it useful for embedded systems. This package provides
 only the run-time libraries.
 .
 This package provides the C library, compiled for a 32 bit execution
 environment.

Package: lib64c0.9.30.1uc
Section: libs
Architecture: any
Description: Small C library implementation - 64 bit C library
 uClibc is an implementation of the standard C library that is much smaller
 than glibc, which makes it useful for embedded systems. This package provides
 only the run-time libraries.
 .
 This package provides the C library, compiled for a 64 bit execution
 environment.

Package: libm0.9.30.1uc
Section: libs
Architecture: any
Description: Small C library implementation - C library
 uClibc is an implementation of the standard C library that is much smaller
 than glibc, which makes it useful for embedded systems. This package provides
 only the run-time libraries.
 .
 This package provides the mathematical library.

Package: lib32m0.9.30.1uc
Section: libs
Architecture: any
Description: Small C library implementation - C library
 uClibc is an implementation of the standard C library that is much smaller
 than glibc, which makes it useful for embedded systems. This package provides
 only the run-time libraries.
 .
 This package provides the mathematical library, compiled for a 32 bit
 execution environment.

Package: lib64m0.9.30.1uc
Section: libs
Architecture: any
Description: Small C library implementation - C library
 uClibc is an implementation of the standard C library that is much smaller
 than glibc, which makes it useful for embedded systems. This package provides
 only the run-time libraries.
 .
 This package provides the mathematical library, compiled for a 64 bit
 execution environment.

=== debian/rules ===
#! /usr/bin/make -f

DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
CROSS =
else
CROSS = $(DEB_HOST_GNU_TYPE)-
endif

parallel = $(patsubst parallel=%,-j%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))

version = 0.9.30.1

pwd = $(shell pwd)

packages_arch_uclibc_linux_amd64_debian = uclibc$(version) uclibc-dev
packages_arch_uclibc_linux_armel_debian = uclibc$(version) uclibc-dev
packages_arch_uclibc_linux_armebuc_debian = uclibc$(version) uclibc-dev
packages_arch_uclibc_linux_powerpc_debian = uclibc$(version) uclibc-dev
packages_arch_uclibc_linux_emdebian = libc$(version)uc libm$(version)uc

packages_indep_debian = uclibc-source

config_uclibc_linuc_amd64_debian = config-amd64
config_uclibc_linuc_armel_debian = config-armel
config_uclibc_linuc_armebuc_debian = config-armebuc
config_uclibc_linuc_powerpc_debian = config-powerpc

arch_uclibc_linuc_amd64_debian = x86_64
arch_uclibc_linuc_armel_debian = arm
arch_uclibc_linuc_armebuc_debian = arm
arch_uclibc_linuc_powerpc_debian = powerpc

vendor = $(shell \
    dpkg-vendor --derives-from emdebian && echo emdebian || \
    dpkg-vendor --derives-from debian && echo debian)

ifeq ($(vendor),)
$(error Vendor not supported)
endif

host = $(DEB_HOST_ARCH:-=_)

type = $(host)_$(vendor)

config = $(config_$(type))
arch = $(arch_$(type))

packages_arch = $(packages_arch_$(type))
packages_indep = $(packages_indep_$(vendor))

build: build-arch build-indep
build-arch: $(packages_arch:%=build-%)
build-indep: $(packages_indep:%=build-%)

binary: binary-arch binary-indep
binary-arch: $(packages_arch:%=binary-%)
	@
binary-indep: $(packages_indep:%=binary-%)
	@

clean:
	dh_testdir
	dh_testroot
	dh_clean
	$(RM) -r build

build-uclibc$(version): build-default

build-default: build/default/.config
	$(MAKE) $(parallel) libs O=$(pwd)/build/default ARCH=$(arch) CROSS=$(CROSS)

build/default/.config: debian/$(config)
	dh_testdir
	mkdir -p build/default
	cp $< $@

ifneq ($(interactive),)
debian/$(config):
	dh_testdir
	mkdir -p build/default
	$(MAKE) $(parallel) menuconfig O=$(pwd)/build/default ARCH=$(arch)
	cp build/default/.config $@
endif

build-uclibc-source: build/uClibc-$(version).tar.bz2

build/uClibc-$(version).tar.bz2: build/uClibc-$(version).tar
	bzip2 -9k <$< >$@

build/uClibc-$(version).tar:
	dh_testdir
	mkdir -p build
	tar -cf $@ --exclude=./build --transform s@^\.@uClibc-$(version)@ .

binary-%: build-%
	dh_testdir
	dh_testroot
	dh_prep -p$*
	dh_installchangelogs -p$*
	dh_installdocs -p$*
	dh_install -p$*
	dh_compress -p$*
	dh_fixperms -p$*
	dh_installdeb -p$*
	dh_shlibdeps -p$*
	dh_gencontrol -p$*
	dh_md5sums -p$*
	dh_builddeb -p$*
